--3D Surface Visualisation 
--Version 1.3 Feb 97

without type_check

include graphics.e
include image.e
include get.e
include mouse.e
include putsxy.e
include compute.e

sequence V, Obs, Z,Mouse_position
sequence U_vect_V,Pi, PiObs, PiObs_vect_U, PiObs_vect_V, Omega
sequence X_Line, Surface, Maille1, Maille2
sequence Theta_area, Phi_area, Robs_area, Rscreen_area, x_0_area, y_0_area,L_area
sequence Exit_area,D_Linear_area,D_Angular_area, Autoscale_area, Frame_area
sequence Init_area

atom L, DeltaX, DeltaY, x , y, DeltaIx, DeltaIy,Mumin,Mumax 
atom NbPoints,z,xr,yr,Xmin,Ymin,D_Linear, D_Angular,AMu, BMu, Mu 
atom Theta, Phi, Robs, DRobs, Rscreen,cTheta, sTheta,Color
atom Mouse_event,continue, Autoscale, Frame

constant Degre_Rad=(3.14159/180)                      
constant U={0,1,0}
constant TwoD_Pnt={0,0}

--Section of local functions

function Clip(atom lambda, atom mu)
if lambda>480 then lambda= 480 end if
if lambda<0 then lambda=0 end if
if mu>480 then mu=480 end if
if mu<0 then mu=0 end if
return {floor(lambda), floor(mu)}
end function

function Inner_product(sequence U, sequence V)
sequence R
if ((length(U)=3) and (length(V)=3)) then
R={0,0,0}
R[1]=U[2]*V[3]-V[2]*U[3]
R[2]=V[1]*U[3]-U[1]*V[3]
R[3]=U[1]*V[2]-U[2]*V[1]
return R
else
return {}
end if
end function

function Dot_product(sequence U, sequence V)
sequence R
atom s
if length(U)=length(V) then
R=U*V
s=0
for i=1 to length(U) do
 s=s+R[i]
end for
return s
else
return {}
end if
end function

function Project(sequence Point)
sequence MiMo
atom lambda, mu
MiMo=Obs-Point
lambda=Dot_product(MiMo,PiObs_vect_V)/Dot_product(MiMo,U_vect_V)
mu=Dot_product(MiMo,PiObs_vect_U)/Dot_product(MiMo,-1*U_vect_V)
return {lambda,mu}
end function

function in(sequence loc, sequence pos)
if (loc[1]<pos[1])and(pos[1]<loc[2])and(loc[3]<pos[2])and(pos[2]<loc[4])then
return 1
else 
return 0
end if
end function

procedure Event_mouse()
object event
event=get_mouse()
if sequence(event) then 
Mouse_position=event[2..3]
Mouse_event=event[1]
else
Mouse_event=event
end if
end procedure

procedure Clear_graph()
polygon(BLACK,1,{{0,0},{0,480},{480,480},{480,0}})
end procedure

procedure Gauge(sequence Name, sequence Value, sequence Position)
 putsxy(Position,Name&" "&Value,WHITE,BLACK,'a')
end procedure

procedure Draw_surface()

--To avoid having to project hidden points in the back of the observer

  if Rscreen<L/2 then
  Rscreen=L/2
  Gauge("R_Scr",sprintf("%f",Rscreen),{500,120})
  end if
  
  if DRobs<=0 then
  DRobs=1
  Gauge("DR_Obs",sprintf("%f",DRobs),{500,100})
  end if

  Robs=Rscreen+DRobs

--Section with parameter dependant 'constants'

cTheta=cos(Theta)
sTheta=sin(Theta)

Obs={Robs*cos(Phi),0,Robs*sin(Phi)}
Pi={Rscreen*cos(Phi),0,Rscreen*sin(Phi)}

PiObs=Obs-Pi

V={-sin(Phi),0,cos(Phi)}


X_Line=repeat(TwoD_Pnt,NbPoints)
Surface=repeat(X_Line,NbPoints)
Z=repeat(0,NbPoints)
Z=repeat(Z,NbPoints)

Xmin=-L/2
Ymin=-L/2

DeltaX=L/(NbPoints-1)
DeltaY=DeltaX
DeltaIx=480/L
DeltaIy=DeltaIx

--System constants

PiObs_vect_U=Inner_product(PiObs,U)
PiObs_vect_V=Inner_product(PiObs,V)                                    
U_vect_V=Inner_product(U,V)

--Projection
Mumin=1.0E300
Mumax=1.0E-300

x=Xmin
for i=1 to NbPoints do
y=Ymin
 for j=1 to NbPoints do
 xr=Omega[1]+x*cTheta-y*sTheta
 yr=Omega[2]+x*sTheta+y*cTheta
 z=Compute(xr,yr)
  Z[i][j]=z
  Surface[i][j]=Project({x,y,z})
  Mu= Surface[i][j][2]
  if Mumin>Mu then Mumin=Mu end if
  if Mumax<Mu then Mumax=Mu end if 
  y=y+DeltaY
 end for
 x=x+DeltaX
end for

if Autoscale then
 AMu=480/(Mumin-Mumax)
 BMu=480*Mumax/(Mumax-Mumin)
else
 AMu=-DeltaIy
 BMu=240
end if

for i=1 to NbPoints do
 for j=1 to NbPoints do
  Surface[i][j]=Clip(240+DeltaIx*Surface[i][j][1],BMu+AMu*Surface[i][j][2])
 end for
end for


--Drawing

Clear_graph()

for i=1 to NbPoints-1do
 for j=1 to NbPoints-1do
 
 Maille1={Surface[i][j],Surface[i][j+1],Surface[i+1][j]}
 Maille2={Surface[i+1][j],Surface[i][j+1],Surface[i+1][j+1]}

if 1-Frame then
 if Z[i][j]- Z[i+1][j]>0 then
  polygon(BRIGHT_WHITE,1,Maille1)
  else
  polygon(WHITE,1,Maille1)
 end if
 if Z[i][j+1]- Z[i+1][j+1]>0 then
  polygon(BRIGHT_WHITE,1,Maille2)
 else
  polygon(WHITE,1,Maille2)
 end if
end if

if 1-Frame then
Color=GRAY
else
Color=BRIGHT_WHITE
end if

  polygon(Color,0,Maille1)
  polygon(Color,0,Maille2)
  
 end for
end for
end procedure


procedure Init()

Mouse_position={0,0}
Theta=0
Phi=0

Theta=Theta*Degre_Rad
Phi=Phi*Degre_Rad

D_Linear=5
D_Angular=45

DRobs=10
Rscreen=0

Omega={0,0,0}
L=30

NbPoints=31

Autoscale=0
Frame=0

Gauge("Theta",sprintf("%f",remainder(Theta/Degre_Rad,360)),{500,0})
Gauge("Phi  ",sprintf("%f",remainder(Phi/Degre_Rad,360)),{500,20})
Gauge("x_0  ",sprintf("%f",Omega[1]),{500,40})
Gauge("y_0  ",sprintf("%f",Omega[2]),{500,60})
Gauge("L    ",sprintf("%f",L),{500,80})
Gauge("DR_Obs",sprintf("%f",DRobs),{500,100})
Gauge("R_Scr ",sprintf("%f",Rscreen),{500,120})
Gauge("D_Linear ",sprintf("%f",D_Linear),{500,160})
Gauge("R_Angular",sprintf("%f",D_Angular),{500,180})
Gauge("Solid  "," ",{500,220})
Gauge("Natural"," ",{500,240})
Gauge("Init","  ",{500,280})
Gauge("        EXIT      "," ",{500,440})

Draw_surface()

end procedure
 
--Section with parameters definition
--Initialisation

bk_color(BLACK)
continue=graphics_mode(18)

Init()

continue=1


--Display Initialisation

Theta_area={500,600,0,20}
Phi_area={500,600,20,40}
x_0_area={500,600,40,60}
y_0_area={500,600,60,80}
L_area={500,600,80,100}
Robs_area={500,600,100,120}
Rscreen_area={500,600,120,140}
D_Linear_area={500,600,160,180}
D_Angular_area={500,600,180,200}
Frame_area={500,600,220,240}
Autoscale_area={500,600,240,260}
Init_area={500,600,280,300}
Exit_area={500,600,440,460}


while continue do

 Event_mouse()
 
 if in(Phi_area,Mouse_position)then
  if (Mouse_event=2) then Phi=Phi+D_Angular*Degre_Rad
  Gauge("Phi  ",sprintf("%f",remainder(Phi/Degre_Rad,360)),{500,20}) 
  Draw_surface()
  end if
  if (Mouse_event=8) then Phi=Phi-D_Angular*Degre_Rad
  Gauge("Phi  ",sprintf("%f",remainder(Phi/Degre_Rad,360)),{500,20}) 
  Draw_surface()
  end if
  
 end if
 
 if in(Theta_area,Mouse_position) then
  if (Mouse_event=2) then Theta=Theta+D_Angular*Degre_Rad
  Gauge("Theta  ",sprintf("%f",remainder(Theta/Degre_Rad,360)),{500,0})
  Draw_surface()
  end if
  if (Mouse_event=8) then Theta=Theta-D_Angular*Degre_Rad
  Gauge("Theta  ",sprintf("%f",remainder(Theta/Degre_Rad,360)),{500,0})
  Draw_surface()
  end if     
 end if
 
 if in(x_0_area,Mouse_position) then
  if (Mouse_event=2) then  
  Omega[1]=Omega[1]+D_Linear 
  Gauge("x_0  ",sprintf("%f",Omega[1]),{500,40})
  Draw_surface()
  end if
  if (Mouse_event=8) then  
  Omega[1]=Omega[1]-D_Linear 
  Gauge("x_0  ",sprintf("%f",Omega[1]),{500,40})
  Draw_surface()
  end if
 end if
 
 if in(y_0_area,Mouse_position) then
  if (Mouse_event=2) then 
  Omega[2]=Omega[2]+D_Linear
  Gauge("y_0  ",sprintf("%f",Omega[2]),{500,60})
  Draw_surface()
  end if
  if (Mouse_event=8) then 
  Omega[2]=Omega[2]-D_Linear
  Gauge("y_0  ",sprintf("%f",Omega[2]),{500,60})
  Draw_surface()
  end if
 end if
 
 if in(D_Linear_area,Mouse_position) then
  if (Mouse_event=2) then 
  D_Linear=D_Linear+1
  Gauge("D_Linear ",sprintf("%f",D_Linear),{500,160})
  end if
  if (Mouse_event=8) then 
  D_Linear=D_Linear-1
  Gauge("D_Linear ",sprintf("%f",D_Linear),{500,160})
  end if
 end if
 
if in(D_Angular_area,Mouse_position) then
 if (Mouse_event=2) then  
 D_Angular=D_Angular+1
 Gauge("D_Angular ",sprintf("%f",D_Angular),{500,180})
 end if 
 if (Mouse_event=8) then  
 D_Angular=D_Angular-1
 Gauge("D_Angular ",sprintf("%f",D_Angular),{500,180})
 end if 
end if

  
if in(Frame_area, Mouse_position)and(Mouse_event=2) then
 Frame=1-Frame
 if Frame=1 then Gauge("Frame"," ",{500,220}) end if
 if Frame=0 then Gauge("Solid"," ",{500,220}) end if
 Draw_surface()
end if

if in(Autoscale_area, Mouse_position)and(Mouse_event=2) then
 Autoscale=1-Autoscale
 if Autoscale=1 then Gauge("Autoscale"," ",{500,240}) end if
 if Autoscale=0 then Gauge("Natural"," ",{500,240}) end if
 Draw_surface()
end if

if in(L_area, Mouse_position) then
 if (Mouse_event=2) then 
 L=L+D_Linear
 Gauge("L    ",sprintf("%f",L),{500,80})
 Draw_surface()
 end if
 if (Mouse_event=8) then 
 L=L-D_Linear
 Gauge("L    ",sprintf("%f",L),{500,80})
 Draw_surface()
 end if
end if

if in(Robs_area, Mouse_position) then
 if (Mouse_event=2) then
 DRobs=DRobs+D_Linear
 Gauge("DR_Obs",sprintf("%f",DRobs),{500,100})
 Draw_surface()
 end if
 if (Mouse_event=8) then
 DRobs=DRobs-D_Linear
 Gauge("DR_Obs",sprintf("%f",DRobs),{500,100})
 Draw_surface()
 end if
end if

if in(Rscreen_area, Mouse_position) then
 if (Mouse_event=2) then
 Rscreen=Rscreen+D_Linear
 Gauge("R_Scr",sprintf("%f",Rscreen),{500,120})
 Draw_surface()
 end if
 if (Mouse_event=8) then
 Rscreen=Rscreen-D_Linear
 Gauge("R_Scr",sprintf("%f",Rscreen),{500,120})
 Draw_surface()
 end if
end if

if in(Init_area, Mouse_position)and(Mouse_event=2) then
 Init()
end if

if in(Exit_area,Mouse_position)and(Mouse_event=2) then
 continue=0 
end if
 
 
end while

continue=graphics_mode(-1)


						   
						  
